<template>
  <div class="h-100 feature-panel" v-if="currentFeature !== null">
    <h3 class="text-center div_title">Fiche de données</h3>
    <form v-if="currentFeature !== null" class="p-3">
        <div v-if="layerOfFeature && layerOfFeature != null">
                <h3 class="text-center text-second font_size_18">
                    {{ layerOfFeature.title }}
                </h3>
            </div>

        <div v-if="allFeatures.length > 1" class="featureList">
          <b-alert show variant="info" dismissible class="mb-0">
            <b-icon icon="arrow-left-square" class="navbtn" @click="previousFeature()"></b-icon>
            {{allFeatures.length}} autres objets à proximité
            <b-icon icon="arrow-right-square" class="navbtn" @click="nextFeature()"></b-icon>
            <span class="link_show" @click="toggleList()">
                <span v-if="!showList">voir plus</span>
                <span v-if="showList">voir moins</span>
            </span>
            <div v-if="showList" class="mt-1">
              <ul class="mb-0">
              <li v-for="(feature, index) in allFeatures" :key="feature.id"
                class="featureListElement"
                @click="changeFeatureIndex(index)">
                {{getDisplayLabel(feature)}}
              </li></ul>
            </div>
            </b-alert>
        </div>
        <div class="container_table mt-2">
          <b-container v-if="!edition">
              <b-row v-for="k of keys" :key="k" class="feature_infos_row">
                <b-col class="feature_infos_cell"> {{getLabel(k)}} </b-col>
                <b-col class="feature_infos_cell" v-if="isLink(k)"> <a target="blank" :href="getValue(k)">{{getValue(k)}}</a> </b-col>
                 <b-col class="feature_infos_cell" v-else>{{getValue(k)}}  </b-col>
              </b-row>
          </b-container>

        <fieldset class="mb-50" v-if="edition">
          <div class="form-group" v-for="k of keysForEdition" :key="k.name">
            <label class="small" :for="'id_'+k.name">{{getLabel(k.name)}}</label>
            <ng-container v-if="k.isText()">
              <input type="text" class="form-control form-control-sm"
              :name="'id_'+k.name" placeholder=""
                v-model="k.value">
            </ng-container>
            <ng-container v-if="k.isNumber()">
              <input type="number" class="form-control form-control-sm"
              :name="'id_'+k.name" placeholder=""
                v-model="k.value">
            </ng-container>
            <ng-container v-if="k.isDateTime()">
              <input type="text" class="form-control form-control-sm"
              :name="'id_'+k.name"
                placeholder="au format YYYY-MM-ddThh:mm:ss" v-model="k.value">
            </ng-container>
            <ng-container v-if="k.isDate()">
              <input type="text" class="form-control form-control-sm" :name="'id_'+k.name"
                placeholder="au format YYYY-MM-dd" v-model="k.value">
            </ng-container>
            <ng-container v-if="k.isBoolean()">
              <input style="margin-left: 10px;" type="checkbox"
              :name="'id_'+k.name" v-model="k.value" />
            </ng-container>
          </div>
        </fieldset>

        </div>
      </form>
      <div style="text-align:center" ref="customContent">
      </div>
    <iframe v-if="hasDataviz()"
            :src="getDatavizUrl()"
            frameborder="0"
            width="530"
            height="600"
            allowtransparency>
    </iframe>
    <!-- Si autorisé, modification des infos de l'objet -->
    <b-row align-v="center" class="mb-2 button-bottom" v-if="!edition">
      <b-col class="text-center">
        <b-button class="w-75 bg_color-second"
          title="Fermer" @click="closePanel()">Fermer la fiche </b-button>
      </b-col>
    </b-row>
    <div class="card-footer" v-if="edition">
      <div class="btn-group w-100" role="group">
        <button type="button" class="btn btn-info" @click="save()">Enregistrer</button>
        <button type="button" class="btn btn-light" @click="cancel()">Annuler</button>
      </div>
    </div>
</div>

</template>

<script lang="ts">
/* eslint-disable max-len */
/* eslint-disable prefer-destructuring */
/* eslint-disable @typescript-eslint/no-this-alias */
/* eslint-disable no-param-reassign */
/* eslint-disable no-underscore-dangle */
/* eslint-disable guard-for-in */
/* eslint-disable no-restricted-syntax */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import LayerAttribute from '@/models/map-context/LayerAttribute';
import LayerConfig from '@/models/map-context/LayerConfig';
import EditionService from '@/services/EditionService';
import { EventBus, EVENTS } from '@/services/EventBus';
import { MapService } from '@/services/MapService';
import { Feature } from 'ol';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';
import PluginComponent from '../plugins/PluginComponent';

@Component({
  props: {
  },
})
export default class FeatureInfosPanel extends PluginComponent {
  static ID='FeatureInfosPanel';

  currentFeature:any=null;

  public keys = Array<any>();

  public showChilds = true;

  public keysForEdition = Array<any>();

  public layerOfFeature: LayerConfig|null=null;

  edition = false;

  allFeatures = [];

  showList=false;

  editionService!:EditionService;

  featureIndex = 0;

  created() {
    const mapService = this.getMapService();
    if (mapService instanceof MapService) {
      this.editionService = mapService.editionService;
    }
  }

  mounted() {
    EventBus.$on(EVENTS.SELECT_FEATURE, this.onFeatureSelected);
    const selectedFeatures = this.getMapService().selectionService.selectedFeature;
    if (selectedFeatures !== undefined) {
      this.onFeatureSelected(selectedFeatures);
    }
  }

  beforeDestroy() {
    EventBus.$off(EVENTS.SELECT_FEATURE, this.onFeatureSelected);
  }

  closePanel() {
    this.currentFeature = null;
    EventBus.$emit(EVENTS.OPEN_LEFT_SIDE_MENU, '');
  }

  toggleList() {
    this.showList = !this.showList;
  }

  onFeatureSelected(features:any) {
    this.featureIndex = 0;
    this.currentFeature = features[this.featureIndex];
    this.allFeatures = features;
    this.parseFeature();
  }

  hasDataviz() {
    if (this.currentFeature) {
      return this.currentFeature.layerConfig.dataviz.active;
    }
    return false;
  }

  getDatavizUrl() {
    if (this.currentFeature) {
      return this.currentFeature.layerConfig.dataviz.getUrl(this.currentFeature);
    }
    return false;
  }

  parseFeature() {
    if (this.currentFeature) {
      this.edition = false;
      if (this.currentFeature) {
        this.layerOfFeature = this.currentFeature.layerConfig;
        if (this.layerOfFeature && this.layerOfFeature.editing) {
          this.edition = true;
        }
      }

      let allkeys = [];

      if (this.currentFeature.getKeys) {
        allkeys = this.currentFeature.getKeys();
      } else {
        const props = this.currentFeature.getProperties();
        for (const p in props) {
          allkeys.push(p);
        }
      }

      this.keys = Array<any>();

      console.log(this.layerOfFeature);
      const self = this;
      if (this.layerOfFeature && this.layerOfFeature.layerProperties
          && this.layerOfFeature.layerProperties.length > 0) {
        const layerProperties = this.layerOfFeature.layerProperties;
        this.keysForEdition = layerProperties.filter((x:LayerAttribute): any => x.name !== this.currentFeature.geometryName_ && x.editable);
        const cf = this.currentFeature;
        this.keysForEdition.forEach((key:any) => {
          console.log(cf.get(key.name));
          key.value = cf.get(key.name);
        });
        // On sélectionne les clefs d'attributs qu'on veut afficher
        allkeys.forEach((key:any): void => {
          console.log(self.currentFeature.get(key));
          if (self.shallDisplayKey(key, layerProperties) && self.currentFeature.get(key) !== undefined) {
            self.keys.push(key);
          }
        });
      } else {
        // On en prend que les key dont la valeur existe réellement.
        allkeys.forEach((key:any) => {
          if (self.currentFeature.get(key)) {
            self.keys.push(key);
          }
        });
      }

      // On retire la géométrie des attributs à montrer
      const geomName = this.currentFeature.geometryName_;
      if (this.keys.indexOf(geomName) >= 0) {
        this.keys.splice(this.keys.indexOf(geomName), 1);
      }
      const target:any = this.$refs.customContent;
      if (this.layerOfFeature?.featureInfoContentRenderer) {
        // eslint-disable-next-line no-unused-expressions
        this.layerOfFeature?.featureInfoContentRenderer(self.currentFeature, target);
      }
    } else {
      // reset le panneau de moficiation
      this.currentFeature = null;
      this.layerOfFeature = null;
    }
  }

  modulo(n:number, m:number):number {
    return ((n % m) + m) % m;
  }

  previousFeature() {
    this.changeFeatureIndex(this.modulo((this.featureIndex - 1), this.allFeatures.length));
  }

  nextFeature() {
    this.changeFeatureIndex(this.modulo((this.featureIndex + 1), this.allFeatures.length));
  }

  changeFeatureIndex(featureIndex:number) {
    this.featureIndex = featureIndex;
    this.currentFeature = this.allFeatures[this.featureIndex];
    this.getMapService().selectionService.cleanSelection();
    this.getMapService().selectionService.addToSelection(this.currentFeature);
    this.parseFeature();
  }

  getDisplayLabel(feature:any) : string {
    console.log(feature);
    // Pour afficher les valeurs des 4 premiers attributs
    const featureTxt = feature.getKeys().filter((x:any) => x !== 'geometry').slice(0, 4).map((x:any) => feature.get(x))
      .join();
    // return `${feature.layerConfig.title}`;
    return `${feature.layerConfig.title}-${featureTxt}`;
  }

  shallDisplayKey(key:string, properties:any) {
    return properties.filter((el:any) => key === el.name && el.display).length > 0;
  }

  isBooleanProperty(property:any) {
    return property.type === 'xsd:boolean';
  }

  isTextProperty(property:any) {
    return property.type === 'xsd:string';
  }

  isDateProperty(property:any) {
    return property.type === 'xsd:date';
  }

  isDateTimeProperty(property:any) {
    return property.type === 'xsd:date-time';
  }

  isNumberProperty(property:any) {
    return property.type === 'xsd:number' || property.type === 'xsd:double' || property.type === 'xsd:int';
  }

  isLink(key:any):boolean {
    const retour = this.getValue(key);
    if (typeof retour === 'string' && retour.indexOf('http') === 0) {
      return true;
    }
    return false;
  }

  getValue(key:any) {
    if (this.currentFeature.get(key) === undefined) {
      return '';
    }
    return this.currentFeature.get(key);
  }

  getLabel(key:any) {
    if (this.layerOfFeature && this.layerOfFeature.layerProperties) {
      const searchAttribute = this.layerOfFeature.layerProperties.filter((data) => data.name === key)[0];
      if (searchAttribute !== undefined && searchAttribute.label !== undefined && searchAttribute.label !== '') {
        return searchAttribute.label;
      }
    }

    return key;
  }

  save(): void {
    console.log('saving feature');
    const self = this;
    this.keysForEdition.forEach((key) => {
      self.currentFeature.set(key.name, key.value);
    });
    if (this.layerOfFeature?.isWFS()) {
      this.editionService.updateFeature(this.currentFeature, this.layerOfFeature, 'update');
    }

    this.edition = false;
    this.parseFeature();
  }

  cancel(): void {
    this.edition = false;
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.navbtn{
  cursor: pointer;
  margin-left: 5px;
  margin-right: 5px;
}
.feature-infos{
  pointer-events: auto;
  max-width: 50vh;
  /*background-image: ;position: absolute;
  top: 37px;
  right: 15px;*/
  border: 1px solid black;
  border-radius: 0px;
  max-height: 70vh;
  background-color: rgba(255, 255, 255, 0.95);
  overflow-y: auto;
}

.featureListElement:hover{
  color: #0056b3;
  text-decoration: underline;
}

.link_show{
  margin-left: 5px;
  color: #007bff;
  text-decoration: none;
  background-color: transparent;
  cursor: pointer;
}
.link_show:hover {
  color: #0056b3;
  text-decoration: underline;
}

table, th, td{
  border: 0px solid #000000 !important;
  cursor: help;
}
.table td, .table th {
  padding: 2px 5px !important;
}

.feature_infos_row{
  border: 0px solid #000000 !important;
}
.feature_infos_row:nth-child(even){
    background-color: fade(@first,10%);
}

.container_table{
  max-height: 70vh;
  overflow-y: auto;
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}

.featureList{
  max-height: 20vh;
  overflow-y: auto;
}
.feature-panel{
  overflow-y: auto;
}
.feature_infos_cell{
  border:0px solid black;
  word-break: break-all;
}

</style>
